:- module(complexity,[complexity/3]).

complexity(weight,X,C) :-
    weight(X,C).
complexity(height,X,C) :-
    height(X,C).

weight(X,1) :-
    var(X),
    !.
weight(T,N) :-
    T =.. [_|Args],
    weight(Args,1,N).

weight([],C,C).
weight([H|L],C0,C) :- 
    weight(H,CH),
    C_ is C0+CH,
    weight(L,C_,C).

height(X,1) :-
    var(X),
    !.
height(T,N) :-
    T =.. [_|Args],
    height(Args,0,N_),
    N is N_ + 1.

height([],C,C).
height([H|L],C0,C) :- 
    height(H,C1),
    (
        C1 > C0
    ->
        height(L,C1,C)
    ;
        height(L,C0,C)
    ).

